require 'picture_handler/version'

module PictureHandler
  autoload :Exceptions, 'picture_handler/exceptions'
  autoload :Configuration, 'picture_handler/configuration'
  autoload :Mounter,  'picture_handler/mounter'
  module Uploader
    autoload :Base, 'picture_handler/uploader/base'
    autoload :MiniMagick, 'picture_handler/uploader/mini_magick'
    autoload :ImgVersion, 'picture_handler/uploader/img_version'
    module FileSystem
      autoload :File, 'picture_handler/uploader/file_system/file'
      autoload :S3, 'picture_handler/uploader/file_system/s3'
    end
  end

  class << self

    attr_writer :configuration

    def configuration
      @configuration ||= Configuration.new
    end

    def configure
      yield configuration
    end

  end

end
