module PictureHandler
  module Uploader
    module FileSystem
      module File

        # -------------------------- #
        # ------   WRITE      ------ #
        # -------------------------- #

          def write_file(image, path_to_write)

            # Create path if it doesn't exist
            self.class.create_directories_for_path( self.class.split_dirname_path(path_to_write) )

            image.write(path_to_write)

            # Raise an exception if the image is not written at the expected location
            unless ::File.exist?(path_to_write)
              raise PictureHandler::Exceptions::WriteError.new(path_to_write)
            end
          end

        # -------------------------- #
        # ------   DELETE     ------ #
        # -------------------------- #

        def delete_all_with_file_system

          infos = info

          #Delete files and directory
          infos[:paths].each { |hash| delete_from_path(hash[:key]) }
          # Delete directory
          Dir.rmdir(infos[:store_dir])

        end

        private

        def delete_from_path(path)
          path = (Rails.root + path).to_s
          if ::File.exist?(path)
            ::File.delete(path)
          else
            puts "ErrorDeletingFile: The file at path: '#{path}' could not be found."
          end
        end

      end
    end
  end
end