module PictureHandler
  module Uploader
    module FileSystem
      module S3

        require 'aws-sdk'

        # -------------------------- #
        # ------   WRITE      ------ #
        # -------------------------- #

        def write_file(image, path_to_write)

          s3_client = Aws::S3::Client.new
          s3_resource = Aws::S3::Resource.new( client: s3_client )

          s3_resource.bucket(PictureHandler.configuration.s3_bucket).object(path_to_write).upload_file(image.path)

        end

        # -------------------------- #
        # ------   DELETE     ------ #
        # -------------------------- #

        def delete_all_with_file_system

          infos = info
          s3_client = Aws::S3::Client.new

          # Get all the objects to delete and delete then in ONE http request
          paths_to_delete = infos[:paths]
          s3_client.delete_objects( bucket: PictureHandler.configuration.s3_bucket, delete: { objects: paths_to_delete } )

        end

      end
    end
  end
end